<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css"
    integrity="sha512-iecdLmaskl7CVkqkXNQ/ZH/XLlvWZOJyj7Yy7tcenmpD1ypASozpmT/E0iPtmFIB46ZmdtAc9eNBvH0H/ZpiBw=="
    crossorigin="anonymous" referrerpolicy="no-referrer" />
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.25/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.25/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
  <div class="container-fluid">
    <div class="text-center mt-2 mb-2">
      <h2>F100 - Quản trị Người dùng</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group mb-0">
        <div class="col-sm-3">
          <label for="voucherCodeInput">Role</label>
        </div>
        <div class="col-sm-6">
          <select id="select-filter-role" class="form-control">

          </select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-role" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
    </div>

    <div class="container-fluid">
      <table class="table table-bordered table-striped table-hover" id="user-table">
        <thead class="thead-dark">
          <tr>
            <th>STT</th>
            <th>UserName</th>
            <th>firstname</th>
            <th>LastName</th>
            <th>Email</th>
            <th>Age</th>
            <th>Role</th>
            <th>Action</th>
          </tr>
        </thead>
      </table>
    </div>
    <script>

      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      // Mảng gUserObjects là mảng chứa dữ liệu users
      var gUserObjects = [
        {
          id: 2,
          username: "quannv",
          firstname: "Ngo Van",
          lastname: "Quan",
          age: 18,
          email: "quan@gmail.com",
          roleId: 5
        },
        {
          id: 3,
          username: "longdh",
          firstname: "Do Hoang",
          lastname: "Long",
          age: 19,
          email: "long@gmail.com",
          roleId: 8
        },
        {
          id: 4,
          username: "hiendt",
          firstname: "Do Thi",
          lastname: "Hien",
          age: 29,
          email: "hien@gmail.com",
          roleId: 11
        },
        {
          id: 6,
          username: "lanht",
          firstname: "Ho Thi",
          lastname: "Lan",
          age: 27,
          email: "lan@gmail.com",
          roleId: 13
        }
      ];
      // Mảng gRoleObjects là mảng chứa dữ liệu các roles
      var gRoleObjects = [
        {
          roleId: 5,
          roleName: "Admin"
        },
        {
          roleId: 8,
          roleName: "Manager"
        },
        {
          roleId: 11,
          roleName: "Teacher"
        },
        {
          roleId: 13,
          roleName: "Staff"
        }
      ];
      var gNameCol = [
        "id",
        "username",
        "firstname",
        "lastname",
        "email",
        "age",
        "roleId",
        "action"
      ];
      const gSTT_COL = 0;
      const gUSER_NAME_COL = 1;
      const gFIRST_NAME_COL = 2;
      const gLAST_NAME_COL = 3;
      const gEMAIL_COL = 4;
      const gAGE_COL = 5;
      const gROLE_COL = 6;
      const gACTION_COL = 7;
      function mappingRoleNameByID(paramData, paramType, paramRow) {
        
        for (let bI = 0; bI < gRoleObjects.length; bI++) {
          const bRoleObjItem = gRoleObjects[bI];
          if (paramData == bRoleObjItem.roleId) {
            return bRoleObjItem.roleName;
          }
        }
      }


      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      $(document).ready(function () {
        onPageLoading();

        $("#btn-filter-role").on("click", function(){
          onBtnFilterClick();
        })

        $("#user-table").on("click", ".btn-dice", function(){
          onBtnDiceHistoryClick(this);
        })
      })
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoading() {
        loadDataToTable()
        loadDataToRoleSelect()
        

      }

      // hàm lọc dữ liệu
      function onBtnFilterClick(){
        var vRole = {
          role: ""
        }

        // thu thập dữ liệu lọc
        getFilter(vRole)
        // lọc Data và hiển thị lên table
        filterRole(vRole)
      
      }
      function onBtnDiceHistoryClick(paramButton){
        var vTable = $("#user-table").DataTable()
        var vRow = $(paramButton).parents("tr")
        var DataRow = vTable.row(vRow).data()
        
        console.log(DataRow)
        window.location.href = "diceHistory.html" 
        + "?username=" + DataRow.username 
        + "&firstname=" + DataRow.firstname 
        + "&lastname=" + DataRow.lastname 
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      // hàm render cột Role

      // hàm loadData lên bảng
      function loadDataToTable(paramData) {
        $("#user-table").DataTable({
          data: gUserObjects,
          columns: [
            { data: gNameCol[gSTT_COL] },
            { data: gNameCol[gUSER_NAME_COL] },
            { data: gNameCol[gFIRST_NAME_COL] },
            { data: gNameCol[gLAST_NAME_COL] },
            { data: gNameCol[gEMAIL_COL] },
            { data: gNameCol[gAGE_COL] },
            { data: gNameCol[gROLE_COL] },
            { data: gNameCol[gACTION_COL] },
          ],
          columnDefs: [
            {
              targets: gROLE_COL,
              className:" text-center",
              render: mappingRoleNameByID
            },
            {
              targets: gACTION_COL,
              class: "text-center",
              defaultContent: `
        <button class="btn btn-link btn-dice" data-toggle="tooltip" title="Dice History"><i class="fas fa-dice text-success"></i></button>
            <button class="btn btn-link btn-sm" data-toggle="tooltip"  title="Voucher History"><i class="fas fa-gift text-success"></i></button>
        `
            }
          ]

        })
      }
      // hàm load Data to Select
      function loadDataToRoleSelect() {
        var vRoleSelect = $("#select-filter-role");
        $("<option/>", {
          text: "--- Chọn tất cả ---",
          value: 0
        }).appendTo(vRoleSelect);

        for (let bI = 0; bI < gRoleObjects.length; bI++) {
          var bPizzaTypeOption = $("<option/>", {
            text: gRoleObjects[bI].roleName,
            value: gRoleObjects[bI].roleId
          }).appendTo(vRoleSelect);
        }
      }

      // thu thập dữ liệu lọc
      function getFilter(paramFilter){
        paramFilter.role = $("#select-filter-role").val()

        console.log(paramFilter.role)
      }

      // hàm lọc dữ liệu

      function filterRole(paramFilter){
      var vResult = gUserObjects.filter(function(item){
        return item.roleId == paramFilter.role || paramFilter.role == 0

       
      })
      loadRoleToTable(vResult)
      console.log(vResult) 
    }
    // hàm load dữ liệu sau khi lọc
    function loadRoleToTable(paramRole){
      var vTable = $("#user-table").DataTable()
      vTable.clear()
      vTable.rows.add(paramRole)
      vTable.draw()
    }
    </script>
</body>

</html>